/* mandayejs - saml reverse proxy
 * Copyright (C) 2015  Entr'ouvert
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var page = require('webpage').create();
var system = require('system');

var input = JSON.parse(system.stdin.read(2000)); // no .readAll()...

headers_list = []

page.viewportSize = {
    width : 1200,
    height : 800
}

page.onResourceReceived = function(response){
    for (var i=0; i < response.headers.length; i++){
        var c_header = response.headers[i];
        if (c_header['name'] === 'Set-Cookie'){
            headers_list.push(c_header);
        }
    }
}

page.open(input.address, function() {
  page.onLoadFinished = function() {
     if (page.injectJs(input.auth_checker)){
         input.auth_success = page.evaluate(function(){
             return auth_success();
         });
     }
    
    if (!input.auth_success){
        console.log(JSON.stringify({'result': 'failure', 'reason': 'authentication failed'}));
        phantom.exit();
    }
    page.render('login.png');
    console.log(JSON.stringify({'result': 'ok', 'cookies': page.cookies, 'headers': headers_list, 'url': page.frameUrl}));
    phantom.exit();
  }
  page.render('home.png');
  page.evaluate(function(input) {
      var locators = input.locators;
      for ( var i=0; i < locators.length; i++ ) { 
          locator = locators[i];
          for ( var key in locator ){
              if (locator.hasOwnProperty(key)){
                  $(key).val(locator[key]);
              }   
          }   
      }
      $(key).parents('form').find(input.form_submit_element).click();
  }, input);
});
