# mandayejs - saml reverse proxy
# Copyright (C) 2015  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from django.db import models
from jsonfield import JSONField
from django.utils.translation import ugettext_lazy as _


class UserCredentials(models.Model):
    user = models.ForeignKey('auth.User')
    locators = JSONField(_('locators'), default={}, blank=True) 
    linked = models.BooleanField(_('associated'), default=True, blank=True)

    class Meta:
        unique_together = ('user',)

    def __unicode__(self):
        return self.user.get_full_name() \
            or self.user.email \
            or self.user.username

    def to_login_info(self):
        return {'#'+k : v for k,v in self.locators.items() if k != 'csrfmiddlewaretoken' }

