# mandayejs - saml reverse proxy
# Copyright (C) 2015  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
import os
import json
import subprocess
from django.conf import settings

import urlparse
from Cookie import SimpleCookie


def exec_phantom(data):
    phantom = subprocess.Popen(['/usr/bin/phantomjs',
        '--ignore-ssl-errors=yes',
        '--ssl-protocol=any',
        '--cookies-file=cookies.txt',
        os.path.join(settings.BASE_DIR, 'mandayejs', 'do_login.js')],
        close_fds=True,
        stdin=subprocess.PIPE,
        stdout=subprocess.PIPE)
    stdout, stderr = phantom.communicate(json.dumps(data))
    result = json.loads(stdout)
    return result

def cookie_builder(headers):
    """Build Cookies from list of headers
    """
    cookie = SimpleCookie()
    for header in headers:
        cookie.load('; '.join(header.values()).encode('ascii'))

    return cookie

def get_location(url):
    """Return path
    """
    url = urlparse.urlparse(url)
    url = url._replace(netloc=settings.SITE_DOMAIN)
    return url.path


